function Erg = localMaxima(U,V,M)

% M = M-1;

%% Histogram
minU = min(U(:));
minV = min(V(:));
[histogram velocities] = hist3([U(:)-minU,V(:)-minV],[100 100]);
figure(1);
imshow(log(histogram+1),[]);
% [y x] = find(histogram>0);
% 
% newV = zeros(1,length(x)); cumU = 1;
% newU = newV; cumV = 1;
%     
% for i=1:length(x);
% 	newUt = ones([1 histogram(y(i),x(i))]) * x(i);
%     newVt = ones([1 histogram(y(i),x(i))]) * y(i);
%     newU(cumU:(cumU+length(newUt)-1)) = newUt;
%     newV(cumV:(cumV+length(newVt)-1)) = newVt;
%     cumU = cumU + histogram(y(i),x(i));
%     cumV = cumV + histogram(y(i),x(i));
% end;

% X = [newU',newV'];
X = [U(:), V(:)];
[idx,ctrs] = kmeans(X,M,'Replicates',10);
% ctrs(end+1,:) = 0;

figure(2);
plot(X(idx==1,1),X(idx==1,2),'r.','MarkerSize',12)
hold on
plot(X(idx==2,1),X(idx==2,2),'b.','MarkerSize',12)
plot(X(idx==3,1),X(idx==3,2),'g.','MarkerSize',12)
plot(ctrs(:,1),ctrs(:,2),'kx','MarkerSize',12,'LineWidth',2)
plot(ctrs(:,1),ctrs(:,2),'ko','MarkerSize',12,'LineWidth',2)
legend('Cluster 1','Cluster 2','Cluster 2','Centroids','Location','NW')

Erg = [ctrs(:,2), ctrs(:,1)];